<?php
/**
 * general.class
 * @author Proper BS
 * @version 1.0 20140107
 * @version update 2.0 20150815
 */
require_once("dbCon.php");
require_once("general.php");

class inventarios{
    public $resultado;
    public $timeZone;
    public $timestamp;
    public $date;
    public $time;

    public function __construct()
    {
        $this->resultado = array();
        $this->timeZone = date_default_timezone_set("America/Guatemala");
        $this->timestamp = date('Y-m-d H:i:s');
        $this->date = date('Y-m-d');
        $this->time = date('H:i:s');
    }

    // Obtiene todas las Bodegas de la Empresa
    public function getBodegas($params){
        $this->resultado = null;

        $sql = "select id, descripcion from bodegas b where idEmpresas = " . $params['idEmpresa'] . " ;";
        
        $query = mysql_query($sql, dbCon::con($params['dbname']));
    	
        while ($ajustes = mysql_fetch_assoc($query)) {
            $this->resultado[] = $ajustes;
        }

        return $this->resultado;
    }

    // Obtiene todas las Sucursales de la Empresa
    public function getSucursales($params){
        $this->resultado = null;

        $sql = "select id, descripcion from sucursales s where idEmpresas = " . $params['idEmpresa'] . " ;";
        
        $query = mysql_query($sql, dbCon::con($params['dbname']));
    	
        while ($ajustes = mysql_fetch_assoc($query)) {
            $this->resultado[] = $ajustes;
        }

        return $this->resultado;
    }
	
    // Obtiene las bodegas y las sucursales de la Empresa
    public function getBodySuc($params){
        $this->resultado = null;

        $sql = "select 2 as tipo, id, descripcion from sucursales s where idEmpresas = " . $params['idEmpresas'] . " 
                union
                select 1 as tipo, id, descripcion from bodegas b where idEmpresas = " . $params['idEmpresas'] . " ;";
        
        $query = mysql_query($sql, dbCon::con($params['dbName']));
    	
        while ($bodysuc = mysql_fetch_assoc($query)) {
            $this->resultado[] = $bodysuc;
        }

        return $this->resultado;
    }

	// Obtiene los usuarios de la empresa
    public function getUsuarios($params){
        $this->resultado = null;

        $sql = "select id, userName from usuarios where idEmpresas = " . $params['idEmpresas'];
        
        $query = mysql_query($sql, dbCon::con($params['dbName']));
    	
        while ($usuarios = mysql_fetch_assoc($query)) {
            $this->resultado[] = $usuarios;
        }

        return $this->resultado;
    } 

    // Obetiene los ajuste en estado 11 = Creado y 12 = En Proceso del Usuario
    public function getAjustes($params){
        $this->resultado = null;

        $sql = "select a.*, DATE_FORMAT(a.created_at, '%d-%m-%Y') as fecha, if(a.inventario = 1, b.descripcion, s.descripcion) as nombre
        from ajustes a 
        left join sucursales s on s.id = a.idPunto
        left join bodegas b on b.id = a.idPunto 
        Where a.idUsuarios=" . $params['idUsuarios'] . " and a.idEmpresas =" . $params['idEmpresas'] . " and a.idEstado in(11, 12) ORDER BY a.id DESC;";
        
        $query = mysql_query($sql, dbCon::con($params['dbName']));
    	
        while ($ajustes = mysql_fetch_assoc($query)) {
            $this->resultado[] = $ajustes;
        }

        return $this->resultado;
    }

    // Crea Ajuste y obtiene el nuevo numero de documento, si el insert es exitoso actualiza el correlativo del documento respectivo.
    public function iniciarAjuste($params){
        $this->resultado = null;
        $documento = $this->getCorrelativo($params['idTipoAjuste'], $params['idUsuarios'], $params['dbName'],$params['idEmpresas']);
        $documentoName = '';
    	
        if ($params['idTipoAjuste'] == 3){
            $documentoName = "ENTRADA " . $documento[0]['serie'] . "-" . $documento[0]['correlativo']; 
        }
        else {
            $documentoName = "SALIDA " . $documento[0]['serie'] . "-" . $documento[0]['correlativo'];
        }
        
        $sql = "INSERT INTO ajustes (inventario, idPunto, idEstado, documento, idTipoAjustes, descripcion, idUsuarios, noFactura, idEmpresas, created_at)" .
               " VALUES(" . $params['tipo'] . ", " . $params['idPunto'].", 11, '" . $documentoName . "'," . $params['idTipoAjuste'] .
                ",'" . $params['descripcion'] . "'," . $params['idUsuarios'] . ", '" . $params['noFactura'] . "', " . $params['idEmpresas'] . ", CURRENT_TIMESTAMP());";

        $ajuste = mysql_query($sql, dbCon::con($params['dbName']));
    	$idAjuste = mysql_insert_id();
        //echo $query;
        if ($ajuste) {
            //OBTIENE ID AJUSTE
            general::updateCorrelativoDocumento($documento['id'], $documento['correlativo'], $params['dbName']);    
            $this->resultado = array('error' => false, 'message' => 'success', 'idAjuste' => $idAjuste);
        }
        else{
            $this->resultado = array('error' => true, 'message' => $ajuste, 'idAjuste' => null);
        }

        return $this->resultado;
    }

	// !! Actualiza la informacion del ajuste antes de que este en proceso
    public function updateAjuste($params){
        $this->resultado = null;

        $sql = "UPDATE ajustes set inventario=" . $params['tipo'] . ", idPunto=" . $params['idPunto'] . ", " .
                "idTipoAjustes=" . $params['idTipoAjustes'] . ", descripcion='" . $params['descripcion'] . "', " .
                "noFactura='" . $params['noFactura'] . "' where id= " . $params['idAjuste'] ;

        $updated = mysql_query($sql, dbCon::con($params['dbName']));

        if($updated){
            $this->resultado = array('error' => false, 'message' => 'success');
        }
        else {
            $this->resultado = array('error' => true, 'message' => 'Error al actualizar del traslado');
        }

        return $this->resultado;
    }

    // Obtiene el correlativo del documento solicitado
    public function getCorrelativo($idDocumento, $idUsuario, $dbName, $idEmpresas){
        $sql = "SELECT id, correlativo, serie FROM documentosCorrelativos dc 
                WHERE idDocumentos = " . $idDocumento . " AND idUsuarios = " . $idUsuario . " ;";

        $query = mysql_query($sql, dbCon::con($dbName));
        
        if(mysql_num_rows($query) == 0){
            if ($idDocumento == 3){
                $sqlT = "SELECT CONCAT_WS(' ','ENTRADA', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(UPPER(roles.descripcion), 1, 1),'E',usuarios.id) AS serie FROM usuarios
                        LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = " . $idUsuario . ";";
                $queryT = mysql_query($sqlT, dbCon::con($dbName));
                $regT = mysql_fetch_assoc($queryT);
            
                $sqlI = "INSERT INTO documentosCorrelativos (idDocumentos,prefijo,serie,correlativo,idFormatos,idAvailablePrint,idUsuarios,idEmpresas,created_at)" .
                        " VALUES (3,
                            '" . $regT['prefijo'] . "',
                            '" . $regT['serie'] . "',
                            1,
                            0,
                            1,
                            '" . $idUsuario . "',
                            '" . $idEmpresas . "',
                            CURRENT_TIMESTAMP());";
                $queryI = mysql_query($sqlI, dbCon::con($params['dbName']));
                if ($queryI == true) {                    
                    $sql = "SELECT id, correlativo, serie FROM documentosCorrelativos dc 
                    WHERE idDocumentos = " . $idDocumento . " AND idUsuarios = " . $idUsuario . " ;";
                    $query = mysql_query($sql, dbCon::con($dbName));

                    while ($documento = mysql_fetch_assoc($query)) {
                        $respuesta[] = $documento;
                    }
                
                } else {
                    $respuesta[] = array('message' => 'failed', 'Query' => $sqlI);
                    return $respuesta;
                }
            }else{
                $sqlT = "SELECT CONCAT_WS(' ','SALIDA', roles.descripcion, usuarios.id) AS prefijo, CONCAT_WS(SUBSTRING(UPPER(roles.descripcion), 1, 1),'S',usuarios.id) AS serie FROM usuarios
                        LEFT JOIN roles ON usuarios.idRoles = roles.id WHERE usuarios.id = " . $idUsuario . ";";
                $queryT = mysql_query($sqlT, dbCon::con($dbName));
                $regT = mysql_fetch_assoc($queryT);
            
                $sqlI = "INSERT INTO documentosCorrelativos (idDocumentos,prefijo,serie,correlativo,idFormatos,idAvailablePrint,idUsuarios,idEmpresas,created_at)" .
                        " VALUES (5,
                            '" . $regT['prefijo'] . "',
                            '" . $regT['serie'] . "',
                            1,
                            0,
                            1,
                            '" . $idUsuario . "',
                            '" . $idEmpresas . "',
                            CURRENT_TIMESTAMP());";
                $queryI = mysql_query($sqlI, dbCon::con($dbName));
                if ($queryI == true) {                    
                    $sql = "SELECT id, correlativo, serie FROM documentosCorrelativos dc 
                    WHERE idDocumentos = " . $idDocumento . " AND idUsuarios = " . $idUsuario . " ;";
                    $query = mysql_query($sql, dbCon::con($dbName));

                    while ($documento = mysql_fetch_assoc($query)) {
                        $respuesta[] = $documento;
                    }
                } else {
                    $respuesta[] = array('message' => 'failed', 'Query' => $sqlI);
                    return $respuesta;
                }
            }
        }else{
            while ($documento = mysql_fetch_assoc($query)) {
                $respuesta[] = $documento;
            }
        }
        return $respuesta;
    }

    // Actualiza el estado del ajuste solicitado
    public function updateEstadoAjuste($idAjuste, $idEstado, $dbName){
        $sql = "update ajustes set idEstado=" . $idEstado . " where id= " . $idAjuste ;

        $updated = mysql_query($sql, dbCon::con($dbName));

        if($updated){
            return true;
        }
        else {
            return false;
        }
    }

//     // Agrega un producto al detalle del ajuste
    public function agregarProductoAjuste($params){
        $this->resultado = null;
        $estadoUpdated = true;

        if($params['idEstado'] == 11){
            // Si es estado es Creado (11) se actualiza a En Proceso (12)
            $estadoUpdated = $this->updateEstadoAjuste($params['idAjuste'], 12, $params['dbName']);
        }

        if($estadoUpdated){
            $sql ="INSERT INTO ajustesDetalle (idAjustes, idProductos, cantidad, idUsuarios) 
            VALUES(" . $params['idAjuste'] . "," . $params['idProducto'] . "," . $params['cantidad'] . "," . $params['idUsuarios'] . ");";

            $producto = mysql_query($sql, dbCon::con($params['dbName']));
        	$idAjustesDetalle = mysql_insert_id();    
        	//echo $query;
            if ($producto) {
                $this->resultado = array('error' => false, 'message' => 'success', 'idEstado' => 12 ,'idAjustesDetalle' => $idAjustesDetalle);
            }
            else{
                $this->resultado = array('error' => true, 'message' => 'Error al insertar ajuste producto', 'sql' => $sql , 'idAjustesDetalle' => null);
            }

        }
        else{
            $this->resultado = array('error' => true, 'message' => 'Error al actualizar estado de ajuste');
        }

        return $this->resultado;
    }

//     // Obtiene los productos del ajuste solicitado
    public function loadProductosAjuste($params){
        $this->resultado = null;

        $sql = "select ad.id, ad.idAjustes, ad.idProductos, p.sku, p.descLarga, ad.cantidad 
        from ajustesDetalle ad
        inner join productos p on p.id = ad.idProductos 
        where idAjustes = " . $params['idAjuste'] . " and idUsuarios =" . $params['idUsuarios'] ;
        
        $query = mysql_query($sql, dbCon::con($params['dbName']));
    	
        while ($productos = mysql_fetch_assoc($query)) {
            $this->resultado[] = $productos;
        }

        return $this->resultado;
    }
	
	// Traslada Ajuste a otro Usuario
    public function trasladarAjuste($params){
        $this->resultado = null;

        $sql = "UPDATE ajustes set idUsuarios=" . $params['idUsuarios'] . " where id= " . $params['idAjuste'] ;

        $updated = mysql_query($sql, dbCon::con($params['dbName']));

        if($updated){
            $this->resultado = array('error' => false, 'message' => 'success');
        }
        else {
            $this->resultado = array('error' => true, 'message' => 'Error al actualizar del traslado');
        }

        return $this->resultado;
    }

	// Obtiene informaciond el ajuste solicitado
    public function getAjuste($params){
        $this->resultado = null;

        $sql = "select * from ajustes Where id=" . $params['idAjuste'];
        
        $query = mysql_query($sql, dbCon::con($params['dbName']));
    	
        while ($ajuste = mysql_fetch_assoc($query)) {
            $this->resultado[] = $ajuste;
        }

        return $this->resultado;
    }

	// Borrar Ajuste solicitado y su detalle (los productos en el)
    // Solo actualizamos el estado para no perder la informacion en caso de error del usuario
    public function deleteAjuste($params){
        $this->resultado = null;

        $sql = "UPDATE ajustes set idEstado=13 where id= " . $params['idAjuste'] ;
		
        $updated = mysql_query($sql, dbCon::con($params['dbName']));

        if($updated){
            $this->resultado = array('error' => false, 'message' => 'success');
        }
        else {
            $this->resultado = array('error' => true, 'message' => 'Error al eliminar ajuste');
        }

        return $this->resultado;
    }

	// Borra el producto de la lista de ajuste detalle
    public function deleteProductoAjuste($params){
        $this->resultado = null;

        $sql = "DELETE FROM ajustesDetalle where id= " . $params['idDetalle'] ;

        $deleted = mysql_query($sql, dbCon::con($params['dbName']));

        if($deleted){
            $this->resultado = array('error' => false, 'message' => 'success');
        }
        else {
            $this->resultado = array('error' => true, 'message' => 'Error al eliminar producto');
        }

        return $this->resultado;
    }
	
	// Traslada todas las cantidades del ajuste al inventario y re calucla los saldos
	public function movimientoInventario($params)
    {
        // Obtiene el detalle de la configuracion del ajuste (Entrada o Salida)
        $detAjuste = $this->getAjuste($params);
        
        if($detAjuste[0]['idTipoAjustes'] == 3){
            $signo = '+';
        	$columna = 'ingreso';
        }
        else{
            $signo = '-';
        	$columna = 'salida';
        }

        // 1. Obtiene el ultimo registro de inventario de cada producto en el carrito de ajustesDetalle
        // 2. SUMA o RESTA la cantidad nueva al ultimo saldo segun sea el tipo de ajuste
        // 3. Inserta el nuevo registro en la tabla de inventarios
        // #. Se filtra con idProducto, ingresoA y idPuntoIngreso
    
        $sql = "INSERT INTO inventarios(ingresoA,idPuntoIngreso,documento, idTipoProductos, idProductos, " . $columna .",saldo,idUsuarios,idEmpresas,created_at)
                SELECT a.inventario as ingresoA , a.idPunto as idPuntoIngreso, a.documento as documento, 
                p.idTipoProductos as idTipoProductos, ad.idProductos as idProductos, ad.cantidad as " . $columna .", 
                (IFNULL(i3.saldo, 0) " . $signo ." ad.cantidad) as saldo, " . $params['idUsuarios'] ." as idUsuarios, " . $params['idEmpresas'] ." as idEmpresas , CURDATE() as created_at
                FROM ajustesDetalle ad
                LEFT JOIN ajustes a ON a.id = ad.idAjustes 
                LEFT JOIN productos p ON p.id = ad.idProductos
                LEFT JOIN (
                    SELECT MAX(id) max_id, idProductos, ingresoA, idPuntoIngreso, saldo
                    FROM inventarios i2
                    GROUP BY idProductos, ingresoA, idPuntoIngreso) i_max ON i_max.idProductos = ad.idProductos AND i_max.ingresoA = a.inventario AND i_max.idPuntoIngreso = a.idPunto
                LEFT JOIN inventarios i3 on i3.id = i_max.max_id
                WHERE ad.idAjustes = " . $params['idAjuste'] ;
        //return $sql;
        $inserted = mysql_query($sql, dbCon::con($params['dbName']));
        
        if($inserted){
            // Actualizar estado de Ajuste a 10 = Terminado
            $this->updateEstadoAjuste($params['idAjuste'], 10, $params['dbName']);
            $this->resultado = array('error' => false, 'message' => 'success');
        }
        else {
            $this->resultado = array('error' => true, 'message' => 'Error al ingresar ajuste');
        }

        return $this->resultado;
    }

	
}